#ifndef __ABSTRACTFATORECONVERTER_H__
#define __ABSTRACTFATORECONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <regexp/RegExp.h>
#include <AlibException.h>

#include "../include/macros.h"
#include "../abstract/Conversion.h"

namespace conversions
{

/**
 * Abstract finite automata to regular expression converter.
 */
class AbstractFAtoREConverter : public Conversion
{
public:
    /**
     * @return regular expression equivalent to source automata.
     */
    virtual regexp::RegExp convert( ) = 0;

    virtual ~AbstractFAtoREConverter( void );

protected:
    /**
     * @param automaton Original FSM.
     */
    AbstractFAtoREConverter( const automaton::FSM & automaton );

    /**
     * Original FSM.
     */
    const automaton::FSM m_automaton;

    /**
     * New RE.
     */
    regexp::RegExp m_re;
};

} /* namespace conversions */

#endif /* __ABSTRACTFATORECONVERTER_H__ */
