/*
 * AbstractFAtoRGConverter.h
 *
 *  Created on: 27. 2. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTFATORGCONVERTER_H_
#define ABSTRACTFATORGCONVERTER_H_

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/RegularGrammar.h>
#include <AlibException.h>

#include "../abstract/Conversion.h"
#include "StateNonterminalMap.h"

namespace conversions
{

/**
 * Abstract finite automata to regular grammar conversion.
 */
class AbstractFAtoRGConverter : public Conversion
{
public:
    /**
     * @param fsm Source automaton.
     */
    AbstractFAtoRGConverter( const automaton::FSM & fsm );

    ~AbstractFAtoRGConverter( void );

protected:
    /**
     * Source automaton.
     */
    const automaton::FSM m_fsm;
};

} /* namespace conversions */

#endif /* ABSTRACTFATORGCONVERTER_H_ */
