/*
 * StateNonterminalMap.cpp
 *
 *  Created on: 15. 3. 2014
 *      Author: tomas
 */

#include "StateNonterminalMap.h"

using namespace alib;
using namespace alphabet;
using namespace automaton;
using namespace grammar;

namespace conversions
{

StateNonterminalMap::StateNonterminalMap( const FSM & fsm, RegularGrammar & grammar ) :
        m_fsm( fsm ),
        m_grammar( grammar )
{
    initMap( );
}

const Symbol & StateNonterminalMap::getNonTerminal( const State & state )
{
    auto it = m_map.find( state );

    // probably harmless to return reference to object stored in map
    if( it != m_map.end( ) )
        return it->second;

    throw AlibException( "No nonterminal for this state! Should not happen unless you manipulated with automata after initialize mapper initialize." );
}

void StateNonterminalMap::initMap( void )
{
    for( const auto & state : m_fsm.getStates( ) )
    {
        Symbol nonTerminal = m_grammar.createUniqueNonTerminalSymbol( state.getName( ), false );
        m_map.insert( make_pair( state, nonTerminal ) );
    }
}

} /* namespace conversions */
