#ifndef __ABSTRACTFATORRGCONVERTER_H__
#define __ABSTRACTFATORRGCONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/RightRegularGrammar.h>
#include <AlibException.h>

#include "../../include/macros.h"
#include "../AbstractFAtoRGConverter.h"

namespace conversions
{

/**
 * Abstract finite automata to right regular grammar.
 */
class AbstractFAtoRRGConverter : public AbstractFAtoRGConverter
{
public:
    /**
     * @return right regular grammar equivalent to source automata.
     */
    virtual grammar::RightRegularGrammar convert( ) = 0;
    virtual ~AbstractFAtoRRGConverter( void );

protected:
    /**
     * New right regular grammar.
     */
    grammar::RightRegularGrammar m_grammar;

    /**
     * @param automaton Original automaton.
     */
    AbstractFAtoRRGConverter( const automaton::FSM & automaton );
};

} /* namespace conversions */

#endif /* __ABSTRACTFATORRGCONVERTER_H__ */
