#ifndef __FATORRGCONVERTER_H__
#define __FATORRGCONVERTER_H__

#include <grammar/Regular/RightRegularGrammar.h>
#include <automaton/FSM/FSM.h>

#include "AbstractFAtoRRGConverter.h"

namespace conversions
{

/**
 * Finite automata to right regular grammar converter.
 * Source: Melichar 2.104
 */
class FAtoRRGConverter : public AbstractFAtoRRGConverter
{
public:
    /**
     * @param automaton Source automata.
     */
    FAtoRRGConverter( const automaton::FSM & automaton );

    ~FAtoRRGConverter( void );

    /**
     * Performs conversion.
     * @return left regular grammar equivalent to source automata.
     */
    grammar::RightRegularGrammar convert ( void );

protected:
    /**
     * New right regular grammar.
     */
    grammar::RightRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* __FATORRGCONVERTER_H__ */
