#ifndef __ABSTRACTRETOFACONVERTER_H__
#define __ABSTRACTRETOFACONVERTER_H__

#include <regexp/RegExp.h>
#include <automaton/FSM/FSM.h>

#include <AlibException.h>

#include "../include/macros.h"
#include "../abstract/Conversion.h"

namespace conversions
{

/**
 * Abstract regular expression to finite automata converter.
 */
class AbstractREtoFAConverter : public Conversion
{
public:
    /**
     * @return FSM equivalent to original regular expression.
     */
    virtual automaton::FSM convert( void ) = 0;

    virtual ~AbstractREtoFAConverter( void );

protected:
    /**
     * @param re Source regular expression.
     */
    AbstractREtoFAConverter(const regexp::RegExp & re );

    /**
     * Source regular expression.
     */
    const regexp::RegExp m_re;

    /**
     * New automaton.
     */
    automaton::FSM m_fsm;
};

} /* namespace conversions */

#endif /* __ABSTRACTRETOFACONVERTER_H__ */
