/*
 * AbstractREtoRRGConverter.h
 *
 *  Created on: 5. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTRETORRGCONVERTER_H_
#define ABSTRACTRETORRGCONVERTER_H_

#include <regexp/RegExp.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../include/macros.h"
#include "../AbstractREtoRGConverter.h"

namespace conversions
{

/**
 * Abstract regular epxression to right regular grammar converter.
 */
class AbstractREtoRRGConverter: public AbstractREtoRGConverter
{
public:
    virtual ~AbstractREtoRRGConverter( void );

    /**
     * @return right regular grammar equivalent to source regexp.
     */
    virtual grammar::RightRegularGrammar convert( void ) = 0;

protected:
    /**
     * @param re Source regular expression.
     */
    AbstractREtoRRGConverter( const regexp::RegExp & re );

    /**
     * New right regular grammar.
     */
    grammar::RightRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* ABSTRACTRETORRGCONVERTER_H_ */
