/*
 * AbstractRRGtoFAConverter.h
 *
 *  Created on: 16. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTRRGTOFACONVERTER_H_
#define ABSTRACTRRGTOFACONVERTER_H_

#include <grammar/Regular/RightRegularGrammar.h>

#include "../AbstractRGtoFAConverter.h"

namespace conversions
{

/**
 * Abstract right regular grammar to finite automata conversion.
 */
class AbstractRRGtoFAConverter: public AbstractRGtoFAConverter
{
public:
    virtual ~AbstractRRGtoFAConverter( void );

protected:
    /**
     * @param rrg Source right regular grammar.
     */
    AbstractRRGtoFAConverter( const grammar::RightRegularGrammar & rrg );

    /**
     * Source grammar.
     */
    const grammar::RightRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* ABSTRACTRRGTOFACONVERTER_H_ */
