/*
 * AbstractRGtoREConverter.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTRGTORECONVERTER_H_
#define ABSTRACTRGTORECONVERTER_H_

#include <regexp/RegExp.h>

#include "../abstract/Conversion.h"

namespace conversions
{

/**
 * Abstract regular grammar to regular expression conversion.
 */
class AbstractRGtoREConverter : public Conversion
{
public:
    /**
     * @return regexp equivalent to source regular grammar.
     */
    virtual regexp::RegExp convert( void ) = 0;

    virtual ~AbstractRGtoREConverter( void );

protected:
    AbstractRGtoREConverter( void );

    /**
     * New regular expression.
     */
    regexp::RegExp m_re;
};

} /* namespace conversions */

#endif /* ABSTRACTRGTORECONVERTER_H_ */
