/*
 * AbstractLRGtoRRGConverter.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTLRGTORRGCONVERTER_H_
#define ABSTRACTLRGTORRGCONVERTER_H_

#include <grammar/Regular/LeftRegularGrammar.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../abstract/Conversion.h"

namespace conversions
{

/**
 * Abstract left regular grammar to right regular grammar converter.
 */
class AbstractLRGtoRRGConverter : public Conversion
{
public:
    virtual ~AbstractLRGtoRRGConverter( void );

    /**
     * @return right regular grammar which is equivalent to source left regular grammar.
     */
    virtual grammar::RightRegularGrammar convert( void ) = 0;

protected:
    /**
     * @param lrg Original left regular grammar.
     */
    AbstractLRGtoRRGConverter( const grammar::LeftRegularGrammar & lrg );

    /**
     * Original left regular grammar.
     */
    const grammar::LeftRegularGrammar m_lrg;

    /**
     * New right regular grammar.
     */
    grammar::RightRegularGrammar m_rrg;
};

} /* namespace conversions */

#endif /* ABSTRACTLRGTORRGCONVERTER_H_ */
