/*
 * AbstractRRGtoLRGConverter.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef ABSTRACTRRGTOLRGCONVERTER_H_
#define ABSTRACTRRGTOLRGCONVERTER_H_

#include "../../abstract/Conversion.h"

#include <grammar/Regular/LeftRegularGrammar.h>
#include <grammar/Regular/RightRegularGrammar.h>

namespace conversions
{

/**
 * Abstract right regular grammar to left regular grammar converter.
 */
class AbstractRRGtoLRGConverter: public Conversion
{
public:
    virtual ~AbstractRRGtoLRGConverter( void );

    /**
     * @return left regular grammar which is equivalent to source right regular grammar.
     */
    virtual grammar::LeftRegularGrammar convert( void ) = 0;

protected:
    /**
     * @param rrg Source right regular grammar.
     */
    AbstractRRGtoLRGConverter( const grammar::RightRegularGrammar & rrg );

    /**
     * Source right regular grammar.
     */
    const grammar::RightRegularGrammar m_rrg;

    /**
     * New left regular grammar.
     */
    grammar::LeftRegularGrammar m_lrg;
};

} /* namespace conversions */

#endif /* ABSTRACTRRGTOLRGCONVERTER_H_ */
