/*
 * RightToLeftRegularGrammar.cpp
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#include "RightToLeftRegularGrammar.h"

using namespace alphabet;
using namespace grammar;
using namespace std;

namespace conversions
{

RightToLeftRegularGrammar::RightToLeftRegularGrammar( const RightRegularGrammar & rrg ) : AbstractRRGtoLRGConverter( rrg )
{

}

RightToLeftRegularGrammar::~RightToLeftRegularGrammar( void )
{

}

LeftRegularGrammar RightToLeftRegularGrammar::convert( void )
{
    for( const auto & symbol : m_rrg.getNonTerminalSymbols( ) )
        m_lrg.addNonTerminalSymbol( symbol );

    for( const auto & symbol : m_rrg.getTerminalSymbols( ) )
        m_lrg.addTerminalSymbol( symbol );

    // 1.
    Symbol s = m_lrg.createUniqueNonTerminalSymbol( m_rrg.getStartSymbol( ).getSymbol( ), false );
    m_lrg.setStartSymbol( s );

    // 2.
    for( const auto & rule : m_rrg.getRules( ) )
    {
        if( rule.getRightSide( ).size( ) == 2 )
        {
            list<Symbol> leftSide = { rule.getRightSide( ).back( ) };
            list<Symbol> rightSide = { rule.getLeftSide( ).front( ), rule.getRightSide( ).front( ) };
            m_lrg.addRule( Rule( leftSide, rightSide ) );

            if( rule.getLeftSide( ).front( ) == m_rrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { rule.getRightSide( ).back( ) };
                list<Symbol> rightSide = { rule.getRightSide( ).front( ) };
                m_lrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else if( rule.getRightSide( ).size( ) == 1 )
        {
            list<Symbol> leftSide = { m_lrg.getStartSymbol( ) };
            list<Symbol> rightSide = { rule.getLeftSide( ).front( ), rule.getRightSide( ).front( ) };
            m_lrg.addRule( Rule( leftSide, rightSide ) );

            if( rule.getLeftSide( ).front( ) == m_rrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { m_lrg.getStartSymbol( ) };
                list<Symbol> rightSide = { rule.getRightSide( ).front( ) };
                m_lrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else
        {
            // assert leftSide == rrg.getStartSymbol( )
            list<Symbol> leftSide = { m_lrg.getStartSymbol( ) };
            list<Symbol> rightSide;
            m_lrg.addRule( Rule( leftSide, rightSide) );
        }
    }

    return m_lrg;
}

} /* namespace conversions */
