/*
 * RightToLeftRegularGrammar.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef RIGHTTOLEFTREGULARGRAMMAR_H_
#define RIGHTTOLEFTREGULARGRAMMAR_H_

#include "AbstractRRGtoLRGConverter.h"

namespace conversions
{

/**
 * Converts right regular grammar to left regular grammar.
 */
class RightToLeftRegularGrammar: public AbstractRRGtoLRGConverter
{
public:
    /**
     * @param rrg Original right regular grammar.
     */
    RightToLeftRegularGrammar( const grammar::RightRegularGrammar & rrg );

    virtual ~RightToLeftRegularGrammar( void );

    /**
     * Performs conversion.
     * @return left regular grammar which is equivalent to source right regular grammar.
     */
    grammar::LeftRegularGrammar convert( void );
};

} /* namespace conversions */

#endif /* RIGHTTOLEFTREGULARGRAMMAR_H_ */
