#ifndef FSMSTRUCTS_H_
#define FSMSTRUCTS_H_

#include <set>
#include "automaton/State.h"

using namespace std;
using namespace automaton;

namespace determinization {
namespace fsm {

/**
 * Struct for storing data about state of deterministic automaton.
 */ 
struct StateData
{

    /** State of deterministic automaton */
    const State state;

    /** 
      * Set of states from nondeterministic automaton which are represented by this state
      *     of deterministic automaton
      */
    const set<State> originalStates;

    /** Indicates if this state is already marked by determinization algorithm or not */
    bool isMarked;
    
    StateData(const State& state, const set<State>& originalStates)
            : state(state),
              originalStates(originalStates),
              isMarked(false) {}
    
};

}
}
#endif
