#ifndef RHDPDADETERMINZER2_H_
#define RHDPDADETERMINZER2_H_

#include <string>
#include <set>
#include <map>
#include <vector>

#include "automaton/PDA/PDA.h"
#include "automaton/Transition.h"
#include "automaton/exception/AutomatonException.h"
#include "alphabet/Symbol.h"

#include "../common/Utils.h"
#include "../Determinizer.h"
#include "RhdpdaUtils.h"
#include "RhdpdaStructs.h"

using namespace std;
using namespace automaton;
using namespace alphabet;
using namespace determinization;

namespace determinization {
namespace rhdpda {

class RhdpdaDeterminizer2 : public Determinizer
{
    private:
        PDA* rhdpda;
        PDA* rdpda;
        map<string, StateData> states;
        set<TransitionPDA> internalTransitions;
        set<TransitionPDA> pushTransitions;
        set<TransitionPDA> popTransitions;
        set<StateSymbolPair> allStateSymbolPairs;
        vector<SComponent> allSComponents;
        vector<RComponent> allRComponents;

        void divideTransitions();
        string buildStackSymbolName(const SComponent& s, const RComponent& r, const Symbol& input);
        set<StateSymbolPair> combineStatesWithSymbol(const set<State>& states, const Symbol& symbol);
        const SComponent getSComponentWithPairsIdentity(const set<StateSymbolPair>& pairs);
        const State& getOrCreateState(const SComponent& s, const RComponent& r);
        void initDeterminization();

    public:
        RhdpdaDeterminizer2(PDA* rhdpda);
        Automaton* determinize();
};

}
}
#endif
