/*
 * RegExpEpsilon.h
 *
 *  Created on: Jan 30, 2014
 *      Author: honza
 */

#ifndef REGEXPEPSILON_H_
#define REGEXPEPSILON_H_

#include "RegExpElement.h"
#include "../alphabet/Epsilon.h"

namespace regexp {

using namespace std;
using namespace alphabet;

/**
 * Represents epsilon in the regular expression.
 */
class RegExpEpsilon: public RegExpElement, public Epsilon {
public:
	RegExpEpsilon();

	/**
	 * @copydoc RegExpElement::clone() const
	 */
	RegExpElement* clone() const;

	virtual bool operator<(const RegExpElement&) const;
	virtual bool operator==(const RegExpElement&) const;
	virtual bool operator>(const RegExpElement&) const;

	virtual bool operator<(const Alternation&) const;
	virtual bool operator<(const Concatenation&) const;
	virtual bool operator<(const Iteration&) const;
	virtual bool operator<(const RegExpSymbol&) const;
	virtual bool operator==(const RegExpEpsilon&) const;

	/**
	 * @copydoc RegExpElement::containsEmptyString() const
	 */
	virtual bool containsEmptyString() const;

	/**
	 * @copydoc RegExpElement::isEmpty() const
	 */
	virtual bool isEmpty() const;
};

} /* namespace regexp */
#endif /* REGEXPEPSILON_H_ */
