/*
 * StringPrinter.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "StringPrinter.h"

namespace notions {
namespace string {

const std::string StringPrinter::INDENTATION = "\t";

void StringPrinter::toXML(const String& string, std::ostream& out) {
	out << "<string>\n";
	printAlphabet(string, out, INDENTATION);
	printContent(string, out, INDENTATION);
	out << "</string>\n";
}

void StringPrinter::printAlphabet(const String& string, std::ostream& out, const std::string & prefix) {
	out << prefix << "<alphabet>\n";
	for (auto element : string.getAlphabet()) {
		printSymbol(element, out, prefix + INDENTATION);
	}
	out << prefix << "</alphabet>\n";
}

void StringPrinter::printContent(const String& string, std::ostream& out, const std::string & prefix) {
	out << prefix << "<content>\n";
	for (auto element : string.getContent()) {
		printSymbol(element, out, prefix + INDENTATION);
	}
	out << prefix << "</content>\n";
}

void StringPrinter::printSymbol(const alphabet::Symbol& element, std::ostream& out, const std::string & prefix) {
	out << prefix << "<symbol>" << element.getSymbol() << "</symbol>\n";
}

} /* namespace string */
} /* namespace notions */
